#include <cstdio>
#include <iostream>
#include <cassert>
#include <vector>
#include <map>
#include <string>
#include <algorithm>
#include <sstream>
#include "testlib.h"

using namespace std;

int cur_test = -1;
vector<int> MAXN({100, 10000, (int)1e5});
const int MAXX = 1000;


string itoa(int x) 
{
    stringstream ss;
    string s;
    ss << x;
    ss >> s;
    return s;
}

int atoi(string s) 
{
    stringstream ss;
    int x;
    ss << s;
    ss >> x;
    return x;
}


void write_test(vector<int> test) 
{
    startTest(cur_test++);
    cerr << cur_test << endl;
    cout << test.size() << endl;
    for (int i = 0; i < (int)test.size() - 1; i++)
        cout << test[i] <<  ' ';
    cout << test.back() << endl;
}


void gen_rand(int n, int maxx)
{
    vector<int> test(n);
    for (int i = 0; i < n; i++) 
    {
        test[i] = rnd.next(maxx) + 1;
    }
    write_test(test);    
}

void gen_ok(int n, int maxx)
{
    vector<int> test(n);
    int mid = rnd.next(maxx) + 1;
    for (int i = 0; i < n; i++) 
    {
        if (i % 2 == 0)
            test[i] = rnd.next(maxx - mid) + mid + 1;
        else
            test[i] = rnd.next(mid) + 1;    
    }
    write_test(test);    
}

void gen_spec1(int n, int maxx)
{
    int mid = rnd.next(maxx) + 1;
    vector<int> test(n, mid);
    int ind = rnd.next(n);
    if (ind % 2 == 0)
        ind++;
    if (ind >= n)
        ind -= 2;
    test[ind] = rnd.next(maxx - mid) + mid + 1;
    write_test(test);    
}

void gen_spec2(int n, int maxx)
{
    int mid = rnd.next(maxx) + 1;
    vector<int> test(n, mid);
    int ind = rnd.next(n);
    if (ind % 2 == 1)
        ind++;
    if (ind >= n)
        ind -= 2;
    test[ind] = rnd.next(mid) + 1;
    write_test(test);    
}


int main(int argc, char * argv[]) 
{
    registerGen(argc, argv, 1);
    cur_test = atoi(argv[1]);
    for (int i = 0; i < (int)MAXN.size(); i++)
    {
        int cur_max = MAXN[i];
        cerr << "start group: " << cur_max << endl;
        
        gen_rand(rnd.next(cur_max) + 1, 10);
        gen_rand(rnd.next(cur_max / 2) + cur_max / 2 + 1, MAXX);
        
        gen_rand(rnd.next(cur_max / 2) + cur_max / 2 + 1, MAXX);
        gen_ok(rnd.next(cur_max / 2) + cur_max / 2 + 1, MAXX); 
        gen_spec1(rnd.next(cur_max / 2) + cur_max / 2 + 1, MAXX);
        gen_spec2(rnd.next(cur_max / 2) + cur_max / 2 + 1, MAXX);

        gen_rand(cur_max, MAXX);
        gen_ok(cur_max, MAXX);
        gen_spec1(cur_max, MAXX);
        gen_spec2(cur_max, MAXX);
        cerr << "end group: " << cur_max << endl;
    }
    return 0;
}